import java.util.Random;

public class DiscreteCA {

    public static void main(String[] args) {
	int m    = args.length/3;                           // m species
	int iter = Integer.parseInt(args[m*3]);             // number of iterations
	int n    = Integer.parseInt(args[args.length - 1]); // grid size

	DTCA dca = new DTCA(n,m,true);

	for (int species=0;species<m;species++){
	    int initialPopulation = Integer.parseInt(args[3*species]);
	    dca.setPBirth(species,Double.parseDouble(args[3*species+1]));
	    dca.setPDeath(species,Double.parseDouble(args[3*species+2]));
	    for (int i=0;i<initialPopulation;i++) dca.add(species);
	}

	for (int i=0;i<iter;i++) dca.doGeneration(i);
	System.exit(0);
    }
}
